// Code generated by easyjson for marshaling/unmarshaling. DO NOT EDIT.

package entity

import (
	json "encoding/json"
	easyjson "github.com/mailru/easyjson"
	jlexer "github.com/mailru/easyjson/jlexer"
	jwriter "github.com/mailru/easyjson/jwriter"
)

// suppress unused package warning
var (
	_ *json.RawMessage
	_ *jlexer.Lexer
	_ *jwriter.Writer
	_ easyjson.Marshaler
)

func easyjson24b46774DecodeGitlabComDennisKhassanHlcupEntity(in *jlexer.Lexer, out *RecommendsAccount) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeString()
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "id":
			out.Id = uint32(in.Uint32())
		case "email":
			out.Email = string(in.String())
		case "fname":
			out.FirstName = string(in.String())
		case "sname":
			out.SecondName = string(in.String())
		case "birth":
			out.Birth = int32(in.Int32())
		case "status":
			out.Status = string(in.String())
		case "premium":
			if in.IsNull() {
				in.Skip()
				out.Premium = nil
			} else {
				if out.Premium == nil {
					out.Premium = new(Premium)
				}
				easyjson24b46774DecodeGitlabComDennisKhassanHlcupEntity1(in, &*out.Premium)
			}
		default:
			in.SkipRecursive()
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
func easyjson24b46774EncodeGitlabComDennisKhassanHlcupEntity(out *jwriter.Writer, in RecommendsAccount) {
	out.RawByte('{')
	first := true
	_ = first
	{
		const prefix string = ",\"id\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Uint32(uint32(in.Id))
	}
	{
		const prefix string = ",\"email\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.Email))
	}
	if in.FirstName != "" {
		const prefix string = ",\"fname\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.FirstName))
	}
	if in.SecondName != "" {
		const prefix string = ",\"sname\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.SecondName))
	}
	{
		const prefix string = ",\"birth\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Int32(int32(in.Birth))
	}
	{
		const prefix string = ",\"status\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.Status))
	}
	if in.Premium != nil {
		const prefix string = ",\"premium\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		easyjson24b46774EncodeGitlabComDennisKhassanHlcupEntity1(out, *in.Premium)
	}
	out.RawByte('}')
}

// MarshalJSON supports json.Marshaler interface
func (v RecommendsAccount) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	easyjson24b46774EncodeGitlabComDennisKhassanHlcupEntity(&w, v)
	return w.Buffer.BuildBytes(), w.Error
}

// MarshalEasyJSON supports easyjson.Marshaler interface
func (v RecommendsAccount) MarshalEasyJSON(w *jwriter.Writer) {
	easyjson24b46774EncodeGitlabComDennisKhassanHlcupEntity(w, v)
}

// UnmarshalJSON supports json.Unmarshaler interface
func (v *RecommendsAccount) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	easyjson24b46774DecodeGitlabComDennisKhassanHlcupEntity(&r, v)
	return r.Error()
}

// UnmarshalEasyJSON supports easyjson.Unmarshaler interface
func (v *RecommendsAccount) UnmarshalEasyJSON(l *jlexer.Lexer) {
	easyjson24b46774DecodeGitlabComDennisKhassanHlcupEntity(l, v)
}
func easyjson24b46774DecodeGitlabComDennisKhassanHlcupEntity1(in *jlexer.Lexer, out *Premium) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeString()
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "start":
			out.Start = int32(in.Int32())
		case "finish":
			out.Finish = int32(in.Int32())
		default:
			in.SkipRecursive()
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
func easyjson24b46774EncodeGitlabComDennisKhassanHlcupEntity1(out *jwriter.Writer, in Premium) {
	out.RawByte('{')
	first := true
	_ = first
	if in.Start != 0 {
		const prefix string = ",\"start\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Int32(int32(in.Start))
	}
	if in.Finish != 0 {
		const prefix string = ",\"finish\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Int32(int32(in.Finish))
	}
	out.RawByte('}')
}
